Historial de cambios del firm de FlashJacks
-------------------------------------------

V2.6 Actualización 19/01/2025
- Se rediseña todo el módulo de RAM de la Flashjacks. Se modifica todos los sincronismos y se pasan al plano de 140Mhz. Todo esto se hace para dar compatibilidad a frecuencias supueriores al standard. Se comprueba estabilidad a 10Mhz.
- El Sampler PCM mostraba ruidos a partir de 10Mhz. Se solventa.
- El beep se reescribe para darle sonido real desde el MSX y no desde un patrón.
- El SCC se resincroniza para darle estabilidad hasta 10Mhz.
- Se usa el pin de Wait de forma más intensiva para dar posibilidad a mayores frecuencias en caso de que la RAM falle en el tiempo de entrega.
- Se añade opción de WAIT Z80 en el bootmenu. De este modo podemos usar las dos versiones de gestión RAM. Sin Waits de espera: La RAM llegará a la velocidad X hasta que empiece a tener pérdida de datos. Con Waits de espera: La RAM pide 
  pausar al Z80 cuando ve que no da más de si. De este modo con unas pocas esperas, da alcance a frecuencias mayores.
- Se corrige un bug en el pin de Busdir. Ahora solo actua exclusivamente en IRQs.
- Se fuerza a que el doble reset actue siempre. Así nos aseguramos con ordenadores conflictivos o que no tienen implementado el pin de WAIT, que el arranque correcto se va a realizar. Se puede anular en el bootmenu.
- Se añade en la carpeta BIN el programa Z80Bench. Con este programa se puede ver la velocidad testeada en directo.

-------------------------------------------

V2.5 Actualización 20/04/2024
- Se actualiza el VgmPlay a la versión 1.4
- Se corrige bug de cuelgue en las OneChip y MSX versiones FPGA. El cuelgue se producía al grabar en el bootmenu.
- Se corrige bug de fallo sincronización en varios módulos en MSX tipo FPGA. El fallo era notable en el Music Module.
- Se optimiza sistema FWAV solicitud de canciones en juegos.
- Se corrige bug del SCC cuando pasa de subslot y se fuerza Slot maestro. En el cambio no se asignaba el slot maestro la detección de SCC.

-------------------------------------------

V2.4 Actualización 15/02/2024
- Se sintetiza módulo Kanji compatible con los carácteres JIS1 y JIS2. Estos se comunican con el MSX via interrupción D8h, D9h, DAh y DBh. Carga automática de KANJI.ROM en directorio raiz con un máximo de 256kB. No ocupa subslots/slots.
- Se corrige un bug nuevo del gestor RAM MAP driver. Desde la versión 2.2 en los MSX2 con poca RAM y uso de la RAM de la Flashjacks, se observa incompatibilidad con la aplicación MAP. Con esta actualización queda solventado.
- Se actualiza las ROMs de FRS del music módule a la versión 1.3b.
-------------------------------------------

V2.3 Actualización 02/02/2024
- Se añade un slot virtual maestro opuesto al slot que está conectada la Flashjacks. Se utiliza para el SCC/DSCC. Con esto capturamos el SCC del slot contrario. Así si insertamos un cartucho original, podemos escucharlo desde la FJ.
- Se añade el tan ansiado ADPCM del Music Module. Ahora ya puedes disfrutar al completo del audio de este dispositivo de sonido.
- Se corrige defecto arranque bootmenu. Para un arranque completo con configuración standard no había problema pero para arranque con todo vacio el tiempo de reset era corto y se quedaba colgado.
-------------------------------------------

V2.2 Actualización 12/01/2024
- Se reescribe la síntesis de actualización del firmware de la FPGA. Ahora es más rápido, más seguro y más confiable. No más brikeos.
- Se corrigen bugs del Bootmenú. Tiene triple chequeo del flasheo. Se añaden textos en caso de que falle la actualización, etc...
- Se corrigen bugs y textos del inglés en el Bootmenú. Ya no se mezclan textos Españoles con el Inglés. Se cambia de idioma de forma instantanea en todos los textos.
- Se incorpora la funcion de no carga en el Slot2. Con esto con la flashjacks en el slot1, podemos forzar a que nuestro MSX no considere la carga inicial del Slot2. 
  Sirve entre otras cosas para programar flashroms y otros hardwares conectados donde no queremos que inicien pero si que estén conectados.
- Se actualiza el sistema Nextor a la versión 2.1.2. Se actualiza FLASHIDE.ROM, EPTCFT.COM, MAPDRV.COM y NEXTOR.SYS.
- Salto de las bios ROM customizadas por las marcas de MSX con arranque propio. Ahora podremos seleccionar parcheo automático para evitar el arranque interno de algunos MSX. 
  Funciona en Panasonic FS-A1, FS-A1F y FS-A1mk2, Sony hb-55/75p, HB-F9P/S, HB-F1, HB-101/201P, Mitsubishi G1 Series, Toshiba Series H, National FS-4000/4500 y otros con el mismo sistema.(Incompatible con ROMs con DSK emulada).
- Se optimiza el acceso de la RAM Flashjacks a la RAM/ROM del MSX. Ahora es superestable permitiendo que al pausar los MSX con este botón, no se corrompa la memoria. También permite slide de frecuencia en los modelos que lo soportan.
- Se automatiza las permutaciones y detecciones SCC/SCC+. En modo SCC se detecta siempre SCC y en SCC+ se detecta SCC/SCC+, permutando automáticamente cuando el software así lo solicite.

-------------------------------------------

V2.1 Actualización 12/11/2022
- Se actualiza el Nextor a 2.1.1 final.(COMMAND2.COM Ver 2.44)
- Se corrige bug de acceso a memoria Flashjacks. Ya no salta el error del comprobación del led rojo porque sí.
- Se corrige bug de reset de los chips de audio. A veces quedaba una nota enganchada.
- Se amplía el bus de audio de 16 a 24bit. Ahora el canal común de audio hasta su salida es a 24bits.
- Se añade la función SPDIF. Con esto tenemos salida digital óptica por el led rojo del cartucho.La salida es formato WAV 24bit stereo 46875kHz.

-------------------------------------------

V2.0 Actualización 26/02/2022
- Se añade función de reproducción WAV en formato PCM y ADPCM. Permite reproducir canciones, pausar, parar,etc... desde el programa FWAV.
- Se añade sistema de disparo de canciones por cambios en posición de memoria. Esto permite cambiar canciones de juegos por WAVs a antojo.
- Se corrige bug PSG donde quedaba el ruido activado en ciertos sitios de forma indefinida (Ej. Aleste2).
- Se corrige bug de Reset. Se alarga el pulso de Reset para que los chips de audio reseteen correctamente evitando artefactos.
- Se corrige otro bug de Reset. Mientras está en reset se le dice a la RAM de la FJ que se desconecte de los refrescos del MSX y haga el refresco vital mínimo para evitar pérdida de datos.

-------------------------------------------

V1.9 Actualización 16/10/2021
- Se solventa problema de estabilidad al guardar la configuración en el bootmenú.
- Se solventa bloqueo sin salida al intentar salir del update con un archivo corrupto en el bootmenú.
- Se actualiza Nextor a 2.1.1 Beta1.
- Se añade indicación de Reset largo. Ahora al pulsar reset tres segundos y efectuar un reset profundo, el led rojo encendido se apagará cuando llegue este tiempo.
- Se añade funciones de Cassette. Ahora puede leer archivos CAS y ejecutarlos en entornos Basic con Subslots FJ y en entornos vacíos. También es capaz de ejecutar mediante entrada de audio de un Cassette externo.
  Es capaz de hacer bypass de la señal, redigitalizando esta. El programa FCAS es capaz de realizar multiples funciones como seleccionar los Baudios, enviar los datos via bus MSX cuando este sea compatible,
  reiniciar el MSX en un entorno limpio y un sinfin de opciones. No es un simple CASduino ya que este mantiene la comunicación directa con el MSX y permite sincronizarse por ejemplo con la señal de Motor,
  rebobinarse automáticamente si interrumpimos el proceso y cargar los .CAS mediante multimente, entre otras cosas. Se ha hecho que sea compatible 100% con MSX1 donde es más necesario. Permite la carga limpia
  para evitar cualquier interferencia con un MSX1 de 64k. Es lo más parecido a un cassette real.
- Esto no es una ventaja, mas bien un inconveniente pero hay que comentarlo. Hemos sobrepasado la capacidad de las primeras FJ. Las modelo 8K ya no podrán ser actualizadas quedandose estas en esta última versión, la V1.9. 
  Comentar que por suerte hay muy pocas unidades y que el 99% son modelos compatibles a esta versión. Siento las molestias que pueda ocasionar esto pero no tengo alternativa si queremos seguir añadiendo funcionalidades.
  Para el resto de modelos comentar que con esta versión estamos al 69% de lo que la Flashjacks puede hacer.

-------------------------------------------

V1.8 Actualización 04/10/2020 (última actualización para las V8)
- Se añade el chip de audio SFG-01/05. Ahora la Flashjacks tiene un nuevo chip de audio incorporado.(Core sound JT51.Jotego.Patreon:https://www.patreon.com/topapate)
- Se mejora la compatibilidad del chip SN76489. Ahora el VGM V1.3 la detecta perfectamente.
- Se sustituye el motor del SN76489 por uno mas perfeccionado. Ahora es fiel al real.(Core sound JT89.Jotego.Patreon:https://www.patreon.com/topapate)
- Se añade la detección en escritura del dual PSG por los puertos 11h y 12h (Los registros 00-17 del PSG se pueden leer por esos puertos indistintamente).
- Se depura el nucleo del PSG. Se eliminan chasquidos de sonidos que hacía en determinadas condiciones.
- Se mejora la suma de canales en el bus de audio.
- Se corrigen bugs en la secuencia de inserción en los slot/subslots virtuales en el CONFIG.CFG. Hay filtraje mas exhaustivo para evitar errores.
- Se actualiza Nextor a 2.1.1 Alpha2.La gestión de archivos se acelera considerablemente.Es versión Alpha.En caso de fallos, volver a copiar el FLASHIDE.ROM de la versión 1.7
- Se actualiza VGMPlay a la versión 1.3

-------------------------------------------

V1.7 Actualización 14/06/2020
- Se revierte la actualización del PSG ya que se observa un mejor realismo con el PSG original de la versión anterior a la 1.6
- El FDSK se compatibiliza para discos internos al pulsar la tecla 0
- Mejorado calibrado de errores en tarjetas SD. Ahora calibra los datos de entrada según velocidad de respuesta SD.
- Aumento de la velocidad de la SD al aceptar funciones de multipaquetes en lectura SD.
- Aumento global de la tasa de lectura notandose en los archivos DSK sobre todo.
- Se corrige bug de mapeado del arranque. Ahora no pierde el mapeado interno cuando se le pide acceso IDE.(No corrompe el MSXDOS).
- Se optimiza consumo de la Flashjacks. Ahora el consumo es variable y no continuo. El consumo se adapta al nucleo de la FPGA según los recursos utilizados. Max aprox 300mA.
- Se programa multiacceso real a la RAM. Ahora varios recursos independientes tienen acceso a la RAM con prioridad MSX.
- Adaptación del EVAplayer a la Flashjacks. Se adapta este programa y se programan los recursos necesarios en la Flashjacks. Ahora es posible el visionado de videos EVA en 10 y 12FPS.(MSX2 y 2+ según video).
- Se programa JacksBoy. Primer hito histórico en un ordenador de 8bits. Se sintetiza un sistema completo dentro de la Flashjacks, compartiendo recursos con el MSX y trabajando de forma simultanea.
  Jacksboy puede correr homebrew y otras aplicaciones. Permite salvado de partidas y otros extras. Audio estereo, joystick, etc.... Compatible a partir de un MSX2 standard.
- Corregido bug en CALL FDISK. No todas las tarjetas detectaba la capacidad real a la primera. Ahora se hace arranque lento en las SD hasta su estado normal de reposo.
- Se añade parpadeo del led azul cuando no se puede inicizalizar la tarjeta SD. Muy util para saber si la ranura o la tarjeta está sucia.
- Se añade al BootMenú la restauración de valores por defectos.
- Se hace doble comprobación en la actualización del Firmware.
- Se corrigen bugs de estabilidad en los accesos a comandos de la Flashjacks en el BootMenu.

-------------------------------------------

V1.6 Actualización 21/09/2019
- Solventado bug sincronismo expansor de slot. Ahora no se cuelga los Sony con Speed Controller. Optimizado sincronismos de la RAM interna Flashjacks.
- Solventado detección Nextor protección contra escritura y fallo de tarjeta SD. Ahora contempla todos estos errores.
- Solventado detección cambio tarjeta en caliente con Nextor. Ahora refresca la estructura de archivos del MSXDOS cada vez que se extrae tarjeta. 
- Añadido buffer de 512 bytes entre la Flashjacks y la SD. Ahora ni las mas rápidas CPUs darán alcance a la tarjeta SD (A no ser que la tarjeta sea extremadamente mala).
- Optimizado el volcado de Nextor y la SD Card. Ahora el volcado es por ciclo de reloj del Z80 tanto lectura como escritura. (tasas de transferencia entre 1200kbit a 2200kbit).
- Se desvincula del driver de la Flashjacks la gestión Sunrise IDE. Ahora se reoptimiza el código y se usan órdenes mas inmediatas. Ya no es compatible Sunrise IDE al 100%.
- Se añade variable de configuración IDIOMA. Ahora todas las aplicaciones pueden consultar el idioma de carga.
- Solventado saturación del "Envelope" en el PSG. Ahora el "Envelope" está al mismo nivel que las baterias. 
- Solventado la detección de SCC+, optimizada ambas detecciones y la síntesis del SCC. Ahora se puede forzar SCC+ a 5 canales reales. El software puede detectar ambos SCC seleccionables. (Solo en mapper Konami5)
- En el FM solventado los clicks al inicio de los instrumentos. También el ruido ciclico del "Vibraphone". Reoptimizado toda la síntesis para mayor calidad y nivelado de los canales de audio.(Si. Ahora se escucha mucho mejor)
- Solventado fallos de sonido en el Bootmenu. También se optimiza el arranque (La opción bootmenú queda al principio y no tiene porque cargar las ROMS cuando se entra al Bootmenu).
- Se optimiza FDSK. Ahora el emulador de discos prescinde totalmente de la RAM del MSX.También se añaden topes a la carga de archivo para parar FATs defectuosas. Por último, se optimiza a velocidad turbo como el driver Nextor. (Victor M.)
- Se corrige bug de borrado eproms con FFh. Ahora escribe al 100% FFh.
- Se añade la implementación de las FlashROM AM29F032 de 4Mb para el mapper ASCII16K y de la AM29F016 de 2Mb para el mapper de ASCII8K, a parte de la AM29F040 de 512Kb para el resto de FlashROMs.
- Se corrige defecto de interpretación en el CONFIG.CFG. Si en el LOAD/SAVE-FILE no había nombre de archivo pero si comandos, dejaba de leer los siguientes LOAD/SAVE. Ahora interpreta si no hay archivo o si falta algún parámetro. 

-------------------------------------------

V1.5 Actualización 27/04/2019
- Actualización del driver NEXTOR a la versión 2.1 beta2.
- Se añade soft de soporte. Ahora sin tarjeta SD da aviso por pantalla.
- Sistema backup/update del firm integrado. Ahora se puede actualizar el firm remotamente.
- Seguimiento contadores de uso integrado en el soft de soporte.
- Edición de los parámetros del config.cfg mediante menus en el propio soft de soporte.
- Optimizado velocidad de trabajo del reloj MSX. Ahora es estable desde el 1Mhz hasta los 5,37Mhz.
- Solventado bug SRAM. No se contemplaba acceso subslot y corrompía la RAM cuando se usaba la externa de Flashjacks. 
  Cuidados con juegos que no gestionen bien los subslots como el YsII. En ese caso no usar RAM Flashjacks si se quiere usar la SRAM.

-------------------------------------------

V1.4.1 Actualización 15/02/2019 (Solo se actualiza soft. Firm 1.4)
- Se añaden archivos de comando de Nextor al bin. (CHKDSK,DISKCOPY,FIXDISK,KMODE,UNDEL,XCOPY,XDIR)
- Se actualiza FDSK de Victor a la V1.3. Ver /BIN/LEEME_FDSK.TXT para mas info.
- Se actualiza FROM de Victor a la V1.59. Ver /BIN/LEEME_FROM.TXT para mas info.
- Se añade DI de Victor en el BIN. (Lista directorios y archivos con nombres largos). Ver /BIN/LEEME_DI.TXT para mas info.

-------------------------------------------

V1.4 Actualización 26/08/2018
- Solventado problema del map en la RAM. Implementado driver de la señal de BUSDIR.
- Optimizado sincronismo interno con el CLOCKSLOT del MSX. Ahora hay sincronización completa entre todos los relojes.
- Se añade PCM via COVOX IO-91h o PCM(TurboR) IO-A4h. Para el PCM(IO-A4h) hace falta un TurboR real o que el programa envíe forzosamente por ese canal.
- Se añade el sistema de audio SN76489 compatible por los puertos I/O 3Fh o 49h. Por supuesto en stereo.
- Se añade operador de audio OPL3 y se compatibiliza en modo FM con el Music Module, con la Moonsound y con el OPL3 nativo. (Puertos I/O C0h a C7h)
- Se añade mapper de FRS 1.3 para el Music Module (Simbiosis ROM-RAM). Esto permite derivar el FM al OPL3 y otras muchas cosas.
- Se añade FDSK creado por Victor. Se trata de un loader de DSK exclusivo para flashjacks con importantes mejoras y compatibilizaciones.
- Se modifica las señales del salida hacia el MSX. Ahora INT y BUSDIR en estado '1' muestra alta impedancia. (Mejora compatibilidad con expansores de slots externos)

-------------------------------------------

V1.3 Actualización 6/05/2018
- Solventado desbloqueo FLASHROM por escritura masiva a partir de la dirección 8000h. Se requiere solicitar borrado por 4000h para acceder a 8000h.
- Se optimizan grabaciones en ASCII8, ASCII16 y KONAMI4.
- Optimizado accesos a ROM/RAM en velocidad variable. Ahora es estable con sliders de reducción de velocidad.
- Solventado bugs en SRAM.
- Optimizado reset interno de la Flashjacks. Ahora los chips se resetean escalonadamente.
- El FMPAC tiene la comprobación RAMSCC. Se usa para tener SCC/FM en un mismo slot/subslot.Util para el segundo SCC.
- Se añade el SCC+ para ambos SCC. Posibilidad de elegir cual de los dos tipos para una mayor compatibilidad.
- Versiones de todo el soft unificado a 1.3.x
- Optimizado driver NEXTOR para mayor estabilidad.
- Se añaden las teclas F4 y F5 para forzar opciones en NEXTOR.
- Si el Jackin está quitado o si el Volin = 0 se desactiva la entrada de audio desde el propio chip. (Menor ruido)
- Evitado reset antes de fin de carga para evitar el bloqueo en grabaciones partidas y corrupción SD.
- Al pulsar 3 segundos seguido el reset, provoca un borrado de RAM para forzar a una situación similar que al hacer un Power.
- Realizado reset soft y comando envío reset flashjacks para MSX1 sin botón de reset. Opción en FROM.
- Optimizado todo el módulo de la RAM Mapper. Los puertos I/O FCh a FFh son capturados tanto en lectura como en escritura. 

-------------------------------------------

V1.2 Actualización 9/04/2018
- Solventado bug de carga Nextor en TurboR
- Doble PSG implementado.
- Implementado función de doble Reset para algunos MSX.
- Implementado Canal A SCC por lado central en Stereo
- Nuevo modo Super stereo (elimina el ambiente espacial y lo deja puro).

-------------------------------------------

V1.1 Actualización 27/03/2018
- Doble SCC implementado
- Entrada de línea para mezcla con audio implementado.
- Regulación de nivel de audio independientes para todos los chips de audio.
- Permutación de niveles de audio por detección de Jack insertado.
- Mejora del nivel de audio del SCC
- Mejora del mezclado digital del audio.
- Mejora carga tarjetas SD.

-------------------------------------------

V1.0 Versión Inicial

